#!/usr/bin/perl
use strict;

#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# The variables below are automatically
# changed by install.pl for the installed
# files. The original files should be left
# alone in order for install.pl to function
# correctly.

my $docroot='/var/www'; # no trailing /
my $scripts='/cgi-bin';  # no trailing /
my $dra='/atengine'; #document root alias
my $atcgi=$scripts.'/at.cgi';
my $counter=$scripts.'/atcounter.cgi';
my $pagetitle='attitle';
my $host=$ENV{'SERVER_NAME'};

sub mydie
{
my $emsg=shift;
print '<html><body>Atengine script error : <br><br>',$emsg,'</body></html>';
exit;
}

my $query = $ENV{'QUERY_STRING'} || '';
my $cookies = $ENV{'HTTP_COOKIE'} || '';
my %refs=();
my %cookie=();
my($param,$value);
my @pairs = split(/[&;]/,$query);
foreach (@pairs)
	{
	($param,$value) = split('=',$_,2);
	$value = '' unless defined $value;
	$refs{$param}=$value;
	}
@pairs=split(/; /, $cookies);
foreach (@pairs)
{
	($param, $value) = split(/=/, $_);
	$cookie{$param} = $value;
}

print "Content-type: text/html\n\n";
$cookie{css}='standard' unless defined $cookie{css} && $cookie{css}=~/^[a-z]+$/;
$refs{node}='home' unless defined $refs{node} && $refs{node}=~/^[a-z]+$/;
$refs{file}='index' unless defined $refs{file} && $refs{file}=~/^[a-z]+$/;
# Limiting to only a-z in node and file names prevents using ../../ to access higher level directories
my $filename=$docroot.'/'.$refs{node}.'/'.$refs{file}.'.txt';
# Absolute file path ensures against mishandling working directory by web
# server, CGI implementation, etc.
mydie ("$filename doesn't exist") unless -e $filename;
open (FILE,$filename) || mydie("Can't open $filename");

# ---to do---
# replace header and trailer layout
# with pure CSS that is XHTML compliant
# ---to do---

print <<EOF;
<html>
<head>
<title>$pagetitle</title>
<link rel="stylesheet" type="text/css" href="$dra/css/$cookie{css}.css">
<style>
#titlebox {width:700px;height:35px;position:relative;top:-5px;line-height:11px;}
#titlemargin{position:absolute;left:2px;width:696px;top:1px;height:33px;}
.atitle   {position:relative;font-size:24px;top:10px;}
.utitle   {position:absolute;top:0px;left:0px;width:50%;text-align:left;font-size:11px;}
.ltitle   {position:absolute;top:19px;left:0px;width:50%;text-align:left;font-size:11px;}
.mainbody {width:700px;text-align:left;clear:both;}
</style>
</head>
<body><center>
<div class="hed" id="titlebox"><div id="titlemargin">
<div class="utitle">
  <a class=hed href="$atcgi?node=home&file=customize&catch=$refs{node}.$refs{file}">Customize</a>
</div>
<div class="utitle" style="text-align:right;left:50%;">
  <a class=hed href="$atcgi?node=$refs{node}&file=index">$refs{node}</a>
</div>
<div class="ltitle">
EOF
if($refs{node} ne 'home'){print"<a class=hed href=\"$atcgi?node=home&file=index\">home</a>";}
print<<EOF;
</div>
<div class="ltitle" style="text-align:right;">
</div>
<span class="atitle">$pagetitle</span>
</div></div>
<div class="mainbody">
EOF

my $t;
while (<FILE>)
{
$_=~/^([#%@!]?)(.*)\n?$/;
$t=$2||'<br>';
$t=~s/\$atcgi/$atcgi/g;
$t=~s/\$host/$host/g;
$t=~s/\$scripts/$scripts/g;
$t=~s/\$counter/$counter/g;
if ($1)
	{
	if($1 eq '#'){print"<p>$t\n";}
	elsif($1 eq '%'){print"<div class=hed>$t</div>\n";}
	elsif($1 eq '!'){print"<span class=bld>$t</span>\n";}
	elsif($1 eq '@'){print qx/.\/blogger.cgi $t/;}
	# assumes blogger.cgi is in the same directory as at.cgi
	# modify path as appropriate
	}
else{print"$t\n";}
}
close FILE;
# Change page trailer as desired
print <<EOF;
</div></center>
<table width="100%"><tr><td width="80%"><td style="text-align:center;font-size:10px;line-height:12px;">
<img src="$dra/home/actionstace.jpg"><br>Powered by<br>Action-Stace</tr></table>
</body></html>
EOF
