#!/usr/bin/perl
use Image::Magick;
use POSIX qw(strftime);
use strict;

#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# This script requires the Image Magick program, and the
# PerlMagick Perl module. If you are using GNU/Linux,
# 'apt-get install perlmagick' as root should install
# everything you need.

if ($ENV{'HTTP_REFERER'}=~/\@/){exit;}  # Don't play nice with
                                        # obfuscated referring URLs

my $query = $ENV{'QUERY_STRING'} || '';
my $cookies = $ENV{'HTTP_COOKIE'} || '';
my %refs=();
my %cookie=();
my($param,$value);
my @pairs = split(/[&;]/,$query);
foreach (@pairs)
	{
	($param,$value) = split('=',$_,2);
	$value = '' unless defined $value;
	$refs{$param}=$value;
	}
@pairs=split(/; /, $cookies);
foreach (@pairs)
{
	($param, $value) = split(/=/, $_);
	$cookie{$param} = $value;
}
my $host=$ENV{'SERVER_NAME'};
my $user=$refs{user}||'count';
my @legalreferrers=(
  $host,
  'cgi.ebay.com/ws/eBayISAPI.dll?ViewItem&category=15584&item=1904744313'
); # Array of beginning referrer addresses that can increment counter.
   # (http|https):// or (http|https)://www. already accounted for

## -- If first chars of counter are 'U-', counter is unique
## -- If first chars of counter are 'D-', counter does noinc on substr($counter,2+)

my $doincrement=0;
if($user=~/^[Dd]\-(\S+)$/){$user=$1;}
elsif($refs{noincrement}||$cookie{"ni$user"}==1){$doincrement=0;}
else
{
  for(@legalreferrers)
  {
    if($ENV{'HTTP_REFERER'}=~/https?\:\/\/(www\.)?$_/){$doincrement=1;}
  }
}

my ($image, $m);  # Image variables
my @files=();     # Image filenames

my $srcdir='/var/www/img/';
my $type=$refs{type}||'verdana';
if(chdir ($srcdir.$type)){$srcdir.=$type.'/';}
else{$srcdir.='verdana/'};

my $countdir='/var/www/user/'; # Picking a directory atengine
                               # already has write access to

my $countfile=$user.'.cnt';
open(FH, $countdir.$countfile);
flock(FH,2);
my $count=<FH>||0;
if($doincrement)
{
  $count++;
  close FH;
  open(FH, '>'.$countdir.$countfile);
  print FH $count;
}
flock(FH,8);
close FH;

binmode STDOUT;
print "Content-type: image/jpeg\n";
if(($user=~/^[Uu]\-/||$refs{'unique'}==1)&&($cookie{"ni$user"}!=1))
{
    my $weekfromnow=strftime "%A, %e-%b-%Y %H:%M:%S GMT", gmtime(time+600000);
    print "Set-Cookie: ni$user=1; path=/; expires=$weekfromnow\n";
}
print "\n";
for(0..length($count)-1)
{
    push(@files,$srcdir.substr($count,$_,1).'.bmp');
}

$image = Image::Magick->new; # create image variable
$image->Read(@files);        # read in all files in @files
$m = $image->Montage(mode=>'Concatenate'); # create $m as one concatenated image
$m->Write('jpg:-');  #print $m to STDOUT as type jpeg
