#!/usr/bin/perl
use IO::Socket;
use URI::Escape;

#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

my $scripts='/cgi-bin';
my $host=$ENV{'SERVER_NAME'};
my $simplehost=$host;
$simplehost=~s/\:.*//;   # trim :8080 and the like off of host name
my $mailfrom='webmaster@'.$simplehost;
chdir '/var/www/user';

$meth=$ENV{'REQUEST_METHOD'} if defined($ENV{'REQUEST_METHOD'});
$content_length = defined($ENV{'CONTENT_LENGTH'}) ? $ENV{'CONTENT_LENGTH'} : 0;
if($meth eq 'POST'){read(\*STDIN,$query,$content_length,0)}
else{$query = $ENV{'QUERY_STRING'};}

@pairs = split(/[&;]/,$query);
my($param,$value);
%refs=();
foreach (@pairs)
	{
	($param,$value) = split('=',$_,2);
	$value = '' unless defined $value;
	$refs->{$param}=uri_unescape($value);
	}

if($refs->{name})  #User clicked link from email that contained name= and reg= variables
	{
	$ref=$refs->{name}.'.ref';
	hackdie('No such user pending') unless(open(REF,$ref));
	$reg=<REF>;$email=<REF>;$psw=<REF>;
	chop $reg;chop $email;chop $psw;
	close REF;
	hackdie('Incorrect registration code') unless($reg eq $refs->{regi});
	#all good, set up user
	$name=$refs->{name};
	if(opendir DH,$name){mydie("Can't set up user, user already exists.");}
	addprob("Can't create directory. Permission problem?") unless(mkdir $name, 0700);
	addprob("Can't cd $name") unless (chdir $name);
        addprob("Can't create .htaccess for $name") unless(open FH,'>.htaccess');
	print FH "Order allow,deny\nDeny from all\n";
	close FH;
        addprob("Can't create user file") unless(open FH,">$name.txt");
	print FH "$email\n$psw\n";
	close FH;
	mydie('Account creation successful');
	}
elsif ($refs->{new}&&$refs->{email}&&$refs->{psw})
	{
        if(opendir DH,$refs->{new}){mydie("Can't set up user, user already exists.");}
	#generate reg code
	$reg='';
	for (1 .. 15) { $reg .= chr(rand(26)+65) }  
	unless(open FH,">$refs->{new}.ref"){addprob("Can't create user file");}
	print FH "$reg\n$refs->{email}\n$refs->{psw}\n";
	close FH;
	chmod 0600, "$refs->{new}.ref";
	#send email with reg code
$sock=IO::Socket::INET->new(PeerAddr=>'localhost',PeerPort =>'25',Proto=>'tcp');
	addprob("Can't connect to mail server") unless $sock;
$sock->autoflush(1);

$line=<$sock>;
if ($line=~/^220/) {print $sock "HELO $simplehost\n";}
else {emaildie($line);}

$line=<$sock>;
if ($line=~/^250/) {print $sock "MAIL FROM:$mailfrom\n";}
else {emaildie($line);}

$line=<$sock>;
if ($line=~/^250/) {print $sock "RCPT TO:$refs->{email}\n";}
else {emaildie($line);}

$line=<$sock>;
if ($line=~/^250/) {print $sock "DATA\n";}
else {emaildie($line);}

$line=<$sock>;
emaildie($line) unless $line=~/^354/;
$reg='&regi='.$reg;
print $sock <<"END";
Subject: Registration for $simplehost

To complete registration, go to the following URL:
http://$host$scripts/new_user.cgi?name=$refs->{new}$reg
.
END
$line=<$sock>;
if ($line=~/^250/) {print $sock "QUIT\n";}
else {emaildie($line);}
$line=<$sock>;
close($sock);
mydie('Registration code generation successful.<p>An email was sent to you with a link to finish registration.');
       }
else {hackdie('Invalid query string');}
exit;

sub addprob()
{
    my $why=shift;
    mydie("Problems adding user<br>$why");
}

sub emaildie()
{
    my $why=shift;
    print $sock "QUIT\n";
    close $sock;
    mydie("Failed to send registration email:<br>$why");
}

sub hackdie()
{
    my $why=shift;
    mydie("<a href=$scripts/newuser.cgi>Sign up</a>, then\ open the link that is<br>emailed to you.<p>$why");
}

sub mydie()
{
    my $reason=shift;
    print "Content-type: text/html\n\n";
    print "<html><body>$reason<p>";
    print "<a href=$scripts/at.cgi?node=journal>Back</a> to main journal page</body></html>\n";
    exit;
}

