#!/usr/bin/perl
use strict;
my %hash=();
my @dirs=grep {-d} <*>;
foreach my $subdir (@dirs)
{
  map
  {
      open FH,$_;
      $/="\n::\n";
      my @photodata=();
      while(<FH>){push(@photodata,$_);}
      my($o,$gallerytitle)=split("\n",$photodata[0]);
      $hash{$o}{title}=$gallerytitle;
      $hash{$o}{dir}=$subdir;
      for(1..$#photodata)
      {
	  my @tmparray=split("\n",$photodata[$_]);
	  $hash{$o}{$_}{image}=shift(@tmparray);
	  $hash{$o}{$_}{title}=shift(@tmparray);
	  if($tmparray[$#tmparray] eq '::'){pop(@tmparray);}
	  $hash{$o}{$_}{comments}=join("\\n",@tmparray);
      }
      close FH;
  } <$subdir/photo.dat>;
}

print<<"EOF";
<html><head>
<script>
//    Copyright 2000-2002 Curtis Autery
//
//    This file is part of atengine.
//
//    atengine is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    atengine is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with atengine; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// Define navigation and comments windows' default HTML values

var stylestring="<style>\\nBODY {font-family: Verdana, Arial, Helvetica, sans-serif; color: #D4D4D4;background: #454545;font-size:12px}\\nA:link {text-decoration: none;font-weight: bold; color: #00B000}\\nA:visited {text-decoration: none;font-weight: bold; color: #00B000}\\nA:active {text-decoration: none; color: #00B000}\\nA:hover {text-decoration: none; background: #5D5D5D;}\\nB {background: #303030; padding-left: .5em;padding-right: .5em}\\nTABLE{font-size:12px}\\n#page_title{text-align:center;font-size:18px;background: #303030;}\\n</style>\\n"

var scriptstring="<scr"+"ipt>function move(loc){opener.location.href=loc;}function updatebyindex(a,b){opener.updatebyindex(a,b);}</scr"+"ipt>\\n";

var navtext=scriptstring+stylestring+"<body onunload='opener.navwindow=null;updatebyindex(-1,-1)'><table width=100%><tr><td width=50%>Photo Set</td><td width=50% align=right>Picture</td></tr>\\n<tr valign=top><td id=navleft></td><td id=navright align=right></td></tr></table></body>";

var comtext=scriptstring+stylestring+"<body onunload='opener.commentswindow=null;updatebyindex(-1,-1)'><center><span id=page_title></span></center><br><div id=comments></div></body>";

// Define holders for current collection/index
var currentcollection;
var currentindex;

// popup window sizes and properties
var alignleft="resizable=1,toolbar=0,menubar=0,scrollbars=1,width=250,height=200,left=0";
var alignright="resizable=0,toolbar=0,menubar=0,scrollbars=0,width=250,height=200";
if (checkfor("screen"))
{
	alignleft+=",top="+(screen.height-275);
	alignright+=",left="+(screen.width-260)+",top="+(screen.height-275);
}

// Init arrays of filenames, directories, and comments
function addcollection(name,directory,titlelist,commentslist,imagelist)
{
this.name=name;
this.directory=directory;
this.titlelist=titlelist;
this.commentslist=commentslist;
this.imagelist=imagelist;
return(this);
}

var collectionlist=new Array();
EOF
my $cnt=0;
for(sort keys %hash)
{
    my $colfirst="collectionlist[$cnt]=new addcollection(";
    my $colsecond='new Array(';
    my $colthird='new Array(';
    my $colfourth='new Array(';
    my $tmphash=$hash{$_};
    $colfirst.="\"$$tmphash{title}\",\"$$tmphash{dir}\",";
    for(sort keys %$tmphash){if($_ ne 'title'&&$_ ne 'dir')
    {
	my $imgarray=$$tmphash{$_};
	$colsecond.="\"$$imgarray{title}\",";
	$colthird.="\"$$imgarray{comments}\",";
	$colfourth.="\"$$imgarray{image}\",";
    }}
    chop $colsecond;chop $colthird;chop $colfourth;
    print $colfirst,"\n",$colsecond,"),\n",$colthird,"),\n",$colfourth,"));\n\n";
    $cnt++;
}

print<<"EOF";
// define HTML list of collections and collection items for navwindow
var collections="";
var items=new Array();
var n=0;
var i=0;
for(n=0;n<collectionlist.length;n++)
  {
  collections+="<a href='javascript:updatebyindex("+n+",0)'>"+collectionlist[n].name+"</a><br>\\n";
  items[n]="";
  for(i=0;i<collectionlist[n].imagelist.length;i++)
  	{
	items[n]+="<a href='javascript:updatebyindex("+n+","+i+")'>"+collectionlist[n].titlelist[i]+"</a><br>\\n";
  	}
  }
// define flag names for browser features and explicitly default to false
var innerhtml=false;
var image0=false;
var byid=false;
var openwindows=false;

// define pop-up window names
var testwindow=null;
var navwindow=null; // navigation window
var commentswindow=null;

function checkfor(prop)
{
var status=false;
if(eval(prop)){status=true;}
return status;
}

function initpage() // Work to do after page body is loaded
{
// define local variables
var n;
var i;
var tempname;

// check browser object model
// if browser is not functional enough,
// exit before an error gets generated

// check for getElementByID
byid=checkfor("document.getElementById");
if(!byid){alert("Can't get element by ID. Stopping.");return;}

// check for innerhtml. Showstopper.
// I use this to dynamically update
// comments and navigation windows.
innerhtml=checkfor("document.getElementById('comments').innerHTML");
if(!innerhtml){alert("Can't update text. Stopping. Using Opera or older browser?");return;}

// check for images array
image0=checkfor("document.images[0]");
if(!image0){alert("Can't update images. Stopping.");return;}

// test for ability to open windows. Not a show-stopper.
testwindow=window.open("","","height=100,width=100");
if(checkwindow("testwindow"))testwindow.close();
for (n=0;n<collectionlist.length;n++)
  {
  tempname=collectionlist[n].directory;
  if(tempname!="")
  for(i=0;i<collectionlist[n].imagelist.length;i++)
    {
    collectionlist[n].imagelist[i]=tempname+'/'+collectionlist[n].imagelist[i];
    }
  }
currentcollection=0;
currentindex=0;
if(openwindows)do_openwindows();
else updatebyindex(-1,-1);
}

function updatebyindex(collection,index)
{
if(collection==-1)collection=currentcollection;else currentcollection=collection;
if(index==-1)index=currentindex;else currentindex=index;
updatetext("commentswindow","page_title",'<b>'+collectionlist[collection].titlelist[index]+'</b>');
updateimage(collectionlist[collection].imagelist[index]);
updatetext("commentswindow","comments",collectionlist[collection].commentslist[index]);
updatetext("navwindow","navleft",collections);
updatetext("navwindow","navright",items[collection]);
}

// function to change innerhtml of
// element with id=(elem) and default window of targetwindow
function updatetext(targetwindow,elem,newtext)
{
var doc=eval(document);
// if target window is open, point command to target window rather than local document
if(eval(targetwindow)&&!eval(targetwindow+".closed"))doc=eval(targetwindow+".document");

// clear element before updating. Helps with Netscape refresh bug
doc.getElementById(elem).innerHTML="";
doc.getElementById(elem).innerHTML=newtext;
}

// pointless function currently. I may add more features later
function updateimage(newimage)
{
document.images[0].src=newimage;
}

function do_openwindows()
{
if(openwindows)
	{
	if(!navwindow)
		{
		navwindow=window.open("","nav",alignright);
		if(!checkwindow("navwindow"))return;
		navwindow.document.open();
		navwindow.document.write(navtext);
		navwindow.document.close(); // document.close != window.close
		document.getElementById('navleft').innerHTML="";
		document.getElementById('navright').innerHTML="";
		}
	navwindow.focus();
	if(!commentswindow)
		{
		commentswindow=window.open("","com",alignleft);
		if(!checkwindow("commentswindow"))return;
		commentswindow.document.open();
		commentswindow.document.write(comtext);
		commentswindow.document.close();
		document.getElementById('comments').innerHTML="";
		document.getElementById('page_title').innerHTML="";
		}
	commentswindow.focus();
	}
updatebyindex(-1,-1);
}

function do_closewindows()
{
if(navwindow)navwindow.close();
if(commentswindow)commentswindow.close();
}

function checkwindow(windowname)
{
// This function is called anytime a window is opened to check
// a) if the window is there, and
// b) if it contains the 'document' object
// If either of these is false, the window is closed, if it
// was ever there, and no other windows are attempted to be
// opened. This helps for browsers like Konqueror
// which can be configured to prompt the user for each
// window.open command. If the user ever says no, this
// assumes no further popups are wanted.
// This does not close any other popups, and they will
// continue to update if updatetext() detects them

openwindows=checkfor(windowname);
if(openwindows)
	{
	openwindows=checkfor(windowname+".document");
	if(!openwindows)
		{
		eval(windowname+".close()");
		alert("Popups work, but have no document object.\\nAre you using an older version of Knoqueror?\\nPage will work, but will not use popups.");
		}
	}
return openwindows;
}
function move(loc){self.location.href=loc;}
</script>
<style>
body{background:black;color:yellow;}
BODY {font-family: Verdana, Arial, Helvetica, sans-serif; color: #D4D4D4;background: #454545;font-size:12px}
A:link {text-decoration: none;font-weight: bold; color: #00B000}
A:visited {text-decoration: none;font-weight: bold; color: #00B000}
A:active {text-decoration: none; color: #00B000}
A:hover {text-decoration: none; background: #5D5D5D;}
B {background: #303030; padding-left: .5em;padding-right: .5em}
#page_title{text-align:center;font-size:18px;}
#picture{height:480px;width:640px;position:relative;top=-10;}
#comments{font-size:18px;width:700px;text-align:justify;}
</style>
</head>
<body onload=initpage() onunload=do_closewindows()>
<center>
<div id=picture>
<a href="javascript:do_openwindows()"><img border=0></a>
</div>
<div style=width:640px>
<table width=100%><tr valign=top><td id=navleft width=33% align=left></td>
<td width=34% align=center>
<span id=page_title>This page may not work with your browser</span>
</td>
<td width=33% id=navright align=right></th>
</tr></table></div>
<div id=comments>
If this message is not replaced after the web page finishes loading, you may have Javascript disabled, or your browser may not be compatible with my code. There is not a legacy version of this page for incompatible browsers.
</div>
</center>
</body></html>
EOF
